package com.fp.persistence.pgeneral.charge;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECHARGESCHECKBOOK*/
@Entity(name="TgeneChargesCheckbook")
@Table(name="TGENECHARGESCHECKBOOK")
public class TgeneChargesCheckbook extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneChargesCheckbook
*/
@EmbeddedId
private TgeneChargesCheckbookKey pk;
@Column(name="CHARGECURRENCYCODE", nullable=true)

/**
* Codigo de moneda en la que esta expresado el cargo
*/
private String chargecurrencycode;

@Column(name="VALUE", nullable=true)

/**
* Costo de la chequera
*/
private BigDecimal value;

/**Contructor por defecto*/
public TgeneChargesCheckbook(){
}
/**Contructor de TgeneChargesCheckbook
@param pPk Clave Primaria del entity
*/
public TgeneChargesCheckbook(TgeneChargesCheckbookKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneChargesCheckbook
*/
public static TgeneChargesCheckbook find(EntityManager pEntityManager,TgeneChargesCheckbookKey pKey) throws Exception{
    TgeneChargesCheckbook obj = pEntityManager.find(TgeneChargesCheckbook.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneChargesCheckbook
@return El objeto que referencia a la Clave primaria de TgeneChargesCheckbook
*/
public TgeneChargesCheckbookKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneChargesCheckbook
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneChargesCheckbook
*/
public void setPk(TgeneChargesCheckbookKey pPk){
  pk=pPk;
}
/**Obtiene el valor de chargecurrencycode
@return valor de chargecurrencycode*/
public String getChargecurrencycode(){
  return chargecurrencycode;
}
/**Fija el valor de chargecurrencycode
@param pChargecurrencycode nuevo Valor de chargecurrencycode*/
public void setChargecurrencycode(String pChargecurrencycode){
  chargecurrencycode=pChargecurrencycode;
}

/**Obtiene el valor de value
@return valor de value*/
public BigDecimal getValue(){
  return value;
}
/**Fija el valor de value
@param pValue nuevo Valor de value*/
public void setValue(BigDecimal pValue){
  value=pValue;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneChargesCheckbook))return false;
    TgeneChargesCheckbook that = (TgeneChargesCheckbook) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneChargesCheckbook
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneChargesCheckbook
*/
public Object createInstance(){
 TgeneChargesCheckbook instance=new TgeneChargesCheckbook();	
 instance.setPk(new TgeneChargesCheckbookKey());
 return instance;
}
/**Clona la entidad TgeneChargesCheckbook
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneChargesCheckbook p=(TgeneChargesCheckbook)this.clone();
  p.setPk((TgeneChargesCheckbookKey)this.pk.cloneMe());
  return p;
}
}
